﻿<?xml version="1.0" encoding="UTF-8"?>
<!--
 *
 * The expansion of the entity-specification for creating an xsd
 *
 *      author Takito, Masaaki
 *
-->

<xsd:schema
	elementFormDefault="qualified"
	targetNamespace="https://gcm.ntt.com/api/xml-schema/v2/expansion-resources/cbe/entity-spec-for-xsd"
	xmlns:cbe-exp01="https://gcm.ntt.com/api/xml-schema/v2/expansion-resources/cbe/entity-spec-for-xsd"

	xmlns:datatypes="https://gcm.ntt.com/api/xml-schema/v2/cbe-datatypes"
	xmlns:cbe="https://gcm.ntt.com/api/xml-schema/v2/common-business-entity"
	xmlns:xsd="http://www.w3.org/2001/XMLSchema">

	<!-- Imports -->
	<xsd:import namespace="https://gcm.ntt.com/api/xml-schema/v2/cbe-datatypes"
			schemaLocation="http://localhost/api/xml-schema/v2/cbe-datatypes/cbe-datatypes.xsd"/>
	<xsd:import namespace="https://gcm.ntt.com/api/xml-schema/v2/common-business-entity"
			schemaLocation="http://localhost/api/xml-schema/v2/cbe-domain/cbe.xsd"/>

	<!--
	 *
	 * XMLスキーマ作成備考
	 *     - xsd ファイル名、名前空間、名前空間接頭辞は以下とする。
	 *         - ファイル名 :
	 *             {ファイル・プリフィックス部}_{バージョン番号}.xsd
	 *         - 名前空間名 :
	 *             {名前空間プリフィックス部}_{バージョン番号}
	 *         - 名前空間接頭辞 :
	 *             {名前空間接頭辞プリフィックス部}_{バージョン番号}
	 *         - バージョン番号は正の整数とする。
	 *     - XML スキーマのエレメントは、entity-specification または
	 *       entity-offering を代替するリソースを構成する各属性項目の情報から
	 *       作成する。
	 *     - データタイプは、属性項目で定義しているデータタイプに基づき、XML
	 *       スキーマがサポートしている適切なデータタイプを選択する。
	 *         - Note. データタイプ毎の書式の詳細についてはXML Schemaについての
	 *           W3C勧告を参照のこと (e.g. XML Schema Part 2: Datatypes)。
	 *     - XMLスキーマの名前空間 (http://www.w3.org/2001/XMLSchema) に対する
	 *       名前空間接頭辞は‘xsd’とする。
	 *     - 属性項目に設定できる属性値の文字数、利用可能文字、数値の範囲、
	 *       フォーマット、などは制約ファセットを設定する。
	 *     - 同様に、属性項目に設定できる属性値の候補値がある場合は enumeration
	 *       で制約ファセットを設定する。
	 *
	-->

	<!-- ■expansion-of-entity-spec-for-xsd (Element) substitution element -->
	<xsd:element name="expansion-of-entity-spec-for-xsd" type="cbe-exp01:ExpansionOfEntitySpecForXsd"
			substitutionGroup="cbe:point-of-expansion">
	</xsd:element>

	<xsd:complexType name="ExpansionOfEntitySpecForXsd">
		<xsd:sequence>
			<xsd:element name="prefix-of-file-name" type="cbe-exp01:PrefixOfFileName" nillable="true" minOccurs="0"/>
			<xsd:element name="prefix-of-namespace" type="cbe-exp01:PrefixOfNamespace" nillable="true" minOccurs="0"/>
			<xsd:element name="prefix-of-namespace-prefix" type="cbe-exp01:PrefixOfFileNamespacePrefix" nillable="true" minOccurs="0"/>
		</xsd:sequence>
		<xsd:attribute name="name" type="xsd:normalizedString" use="optional" />
	</xsd:complexType>


	<xsd:simpleType name="PrefixOfFileName">
		<xsd:restriction base="xsd:NCName">
			<xsd:minLength value="1"/>
			<xsd:maxLength value="50"/>
			<xsd:pattern value="[\p{IsBasicLatin}]+"/>
		</xsd:restriction>
	</xsd:simpleType>

	<xsd:simpleType name="PrefixOfNamespace">
		<xsd:restriction base="xsd:NCName">
			<xsd:minLength value="1"/>
			<xsd:maxLength value="50"/>
			<xsd:pattern value="[\p{IsBasicLatin}]+"/>
		</xsd:restriction>
	</xsd:simpleType>

	<xsd:simpleType name="PrefixOfFileNamespacePrefix">
		<xsd:restriction base="xsd:NCName">
			<xsd:minLength value="1"/>
			<xsd:maxLength value="30"/>
			<xsd:pattern value="[\p{IsBasicLatin}]+"/>
		</xsd:restriction>
	</xsd:simpleType>

</xsd:schema>
